Subject: bug#59637: 29.0.50; Should treesit-range-settings support the possibility of separate parser for each region?

From: Yuan Fu <[email-masked]>
Date: Mon, 28 Nov 2022 14:51:30 -0800

Stefan Kangas <[email-masked]> writes:

> miha--- via "Bug reports for GNU Emacs, the Swiss army knife of text
> editors" <[email-masked]> writes:
>
>> As far as I understand, the current behaviour of
>> treesit-parser-set-included-ranges is that the concatenation of text
>> from different regions in the same range set is considered as one
>> program. This means that for this html program
>>
>>     <html>
>>       <script>
>>         /* comment start
>>       </script>
>>       <script>
>>         alert('hello');
>>       </script>
>>     </html>
>>
>> treesitter would consider "alert('hello');" to be inside a comment and
>> the second script tag would contain an error about missing comment
>> end.
>>
>> However, testing this in Firefox, it seems that the first script tag is
>> the erroneous one here and the alert function call isn't inside a
>> comment. So I guess the correct way to parse this html document would be
>> to have two instances of javascript parser, one for each region. On the
>> other hand, we should consider if this is worth the added complexity and
>> performance degradation.
>>
>> Thanks and best regards.

Yeah it makes sense, but as you say the isolation comes at a cost and I
don’t know if it can be justified right now, because the complexity in
assinging different parsers for each range which can disappear/appear as
the user edits the buffer. Plus the current framework kind of assumes
one parser for each language, so we need some non-trivial change to make
"one parser per range" work smoothly.

For now, I think it’s best to just turn off error highlighting and rely
on tree-sitter’s error recovery. I think that’s what everybody else
does.

In the future if we make the framework more flexible and makes "one
parser per range" easier to implement we can try adding support for it.

> Copying in Yuan Fu.

Thanks :-)

Yuan